# .../addons/eventscripts/_libs/python/mutelib.py

''' Imports '''
from es import getUseridList, voicechat, addons, getuserid
from gamethread import queue
from psyco import full
full()

''' Global Variables '''

__all__ = ['getPlayer']

voice_users = set()
text_users = set()

''' Classes '''

class getPlayer(object):
    def __init__(self,userid):
        self.userid = getuserid(userid)
        if not self.userid:
            raise TypeError, '\'' + userid + '\'is a invalid userid.'

    def muteVoice(self):
        voice_users.add(self.userid)

    def unmuteVoice(self):
        voice_users.discard(self.userid)

    def existsVoice(self):
        return self.userid in voice_users

    def muteText(self):
        text_users.add(self.userid)

    def unmuteText(self):
        text_users.discard(self.userid)

    def existsText(self):
        return self.userid in text_users

''' Tick & Chat Listeners. '''

def tick():
    if voice_users:
        for userid in getUseridList():
            for target in voice_users:
                if target == userid:
                    continue
                voicechat('nolisten', userid, target)
                queue(voicechat, ('nolisten', userid, target))

addons.registerTickListener(tick)

def chat(userid, text, teamonly):
    if userid in text_users:
        return (0, 0, 0)
    return (userid, text, teamonly)

addons.registerSayFilter(chat)

''' Event Handlers '''

def player_disconnect(ev):
    userid = int(ev['userid'])
    voice_users.discard(userid)
    text_users.discard(userid)

addons.registerForEvent(__import__(__name__), 'player_disconnect', player_disconnect)
